<script lang="ts">
	import { PrimaryText, SecondaryText, Text } from '@smui/list';
	import type { Event } from './domain/ScheduleDomain.svelte';
	import { Duration, ZonedDateTime } from '@js-joda/core';
	import LinearProgress from '@smui/linear-progress';

	export let event: Event;
	export let now: ZonedDateTime = ZonedDateTime.now();

	let durationUntilStart: number;
	$: durationUntilStart = Duration.between(now, event.startTime).toMinutes();

	let durationUntilEnd: number;
	$: durationUntilEnd = Duration.between(now, event.endTime).toMinutes();

	let progress: number = -1;
	$: if (durationUntilStart <= 0 && durationUntilEnd > 0) {
		progress = Math.abs(durationUntilStart) / (durationUntilEnd - durationUntilStart);
	}
</script>

<Text class="flex-item-span">
	<PrimaryText>{event.title}</PrimaryText>
	<SecondaryText
		>{#if durationUntilStart > 0}starts in {durationUntilStart} minutes{:else}ends in {durationUntilEnd}
			minutes{/if}</SecondaryText
	>
	{#if progress >= 0}
		<div style="margin: 6px 16px 0 0px">
			<LinearProgress {progress} />
		</div>
	{/if}
</Text>
